package de.intevation.flys.importer;

import de.intevation.flys.model.HYK;
import de.intevation.flys.model.River;

import java.util.List;
import java.util.ArrayList;

import org.hibernate.Session;
import org.hibernate.Query;

public class ImportHYK
{
    protected ImportRiver river;
    protected String      description;

    protected List<ImportHYKEntry> entries;

    protected HYK peer;

    public ImportHYK() {
        entries = new ArrayList<ImportHYKEntry>();
    }

    public ImportHYK(ImportRiver river, String description) {
        this();
        this.river       = river;
        this.description = description;
    }

    public ImportRiver getRiver() {
        return river;
    }

    public void setRiver(ImportRiver river) {
        this.river = river;
    }

    public void addEntry(ImportHYKEntry entry) {
        entries.add(entry);
        entry.setHYK(this);
    }

    public HYK getPeer() {
        if (peer == null) {
            River r = river.getPeer();
            Session session = ImporterSession.getInstance()
                .getDatabaseSession();
            Query query = session.createQuery(
                "from HYK where river=:river and description=:description");
            query.setParameter("river", r);
            query.setParameter("description", description);
            List<HYK> hyks = query.list();
            if (hyks.isEmpty()) {
                peer = new HYK(r, description);
                session.save(peer);
            }
            else {
                peer = hyks.get(0);
            }
        }
        return peer;
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
